=== debian/changelog ===
box64 (0.2.2+dfsg-3) unstable; urgency=medium

  * debian/control: fix dependencies
  * debian/salsa-ci.yml: disable amd64 and enable arm64
  * add use-cross-libs.patch

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Fri, 21 Jul 2023 08:19:36 +0200

box64 (0.2.2+dfsg-2) unstable; urgency=medium

  * debian/copyright: add missing entries

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sun, 16 Jul 2023 23:55:31 +0200

box64 (0.2.2+dfsg-1) unstable; urgency=medium

  * initial upload

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Thu, 06 Jul 2023 23:12:06 +0200
