## box64 0.2.4+dfsg

=== debian/changelog ===
box64 (0.2.4+dfsg-1) unstable; urgency=medium

  * New upstream version 0.2.4+dfsg
  * drop patches
  * add debian/salsa-ci.yml
  * add autopkgtest
  * debian/rules: run loops with -e
  * debian/rules: build with cmake+ninja
  * debian/control: add B-D on ninja-build

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sat, 26 Aug 2023 00:46:05 +0200
