=== debian/changelog ===
box64 (0.2.6+dfsg-3) unstable; urgency=medium

  * debian/box64.install: fix typo PPL64LE->PPC64LE (closes: #1061457)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 24 Jan 2024 22:25:30 +0100

box64 (0.2.6+dfsg-2) unstable; urgency=medium

  * debian/box64.install: fix typo tmp.RV644 -> tmp.RV64

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sun, 24 Dec 2023 23:39:56 +0100

box64 (0.2.6+dfsg-1) unstable; urgency=medium

  * New upstream version 0.2.6+dfsg
  * install box64.conf into /usr/lib/binfmt.d which is where it triggers
    systemd-binfmt restart during installation

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sun, 24 Dec 2023 18:59:12 +0100
