=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
  cmake,
  debhelper-compat (= 13),
  dh-exec,
- python3,
+ ninja-build,
+ python3:native,
 Standards-Version: 4.6.2
 Homepage: https://github.com/ptitSeb/box64
 Rules-Requires-Root: no
