## box64 0.3.0%2Bdfsg

=== debian/changelog ===
box64 (0.3.0+dfsg-1) unstable; urgency=medium

  * New upstream version 0.3.0+dfsg
  * debian/copyright: exclude files for 0.3.0 release
  * add spelling.patch
  * use box64.pod from upstream
  * install CHANGELOG.md and COMPILE.md as docs

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 10 Jul 2024 10:52:34 +0200
