=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
 	set -exu; for p in $(PLATFORMS); do dh_auto_configure --builddirectory=build.$${p} -- -D$${p}=1 -DNOGIT=1 -DNO_LIB_INSTALL=1; done
 
 override_dh_auto_build:
-	pod2man --center "Manual" --release "box64 $(DEB_VERSION_UPSTREAM)" debian/box64.pod > debian/box64.1
+	pod2man --center "Manual" --release "box64 $(DEB_VERSION_UPSTREAM)" docs/box64.pod > docs/box64.1
 	mkdir -p src/wrapped/generated
 	set -exu; for p in $(PLATFORMS); do dh_auto_build --builddirectory=build.$${p}; done
 
@@ -33,6 +33,7 @@
 
 override_dh_auto_clean:
 	set -exu; for p in $(PLATFORMS); do dh_auto_clean --builddirectory=build.$${p}; done
+	rm -f docs/box64.1
 
 # https://github.com/ptitSeb/box64/issues/648
 override_dh_auto_test:
