## box64 0.3.2%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,24 @@
 Source: box64
 Section: utils
 Priority: optional
-Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
-Build-Depends:
- cmake,
- debhelper-compat (= 13),
- dh-exec,
- ninja-build,
- python3:native,
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               dh-exec,
+               ninja-build,
+               python3:native
 Standards-Version: 4.6.2
 Homepage: https://github.com/ptitSeb/box64
 Rules-Requires-Root: no
 
 Package: box64
 Architecture: arm64 ppc64el riscv64
-Depends:
- libgcc-s1:amd64 | libgcc-s1-amd64-cross,
- libstdc++6:amd64 | libstdc++6-amd64-cross,
- ${misc:Depends},
- ${shlibs:Depends},
-Conflicts:
- box64-rk3588,
- box64-rpi4,
+Depends: libgcc-s1:amd64 | libgcc-s1-amd64-cross,
+         libstdc++6:amd64 | libstdc++6-amd64-cross,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Conflicts: box64-rk3588, box64-rpi4
 Description: run amd64 binaries on arm64 without emulating library calls
  Using DynaRec on arm64, box64 will dynamically recompile x64_64 code to
  aarch64 but will also translate calls to foreign library functions to
@@ -35,14 +32,11 @@
 
 Package: box64-rk3588
 Architecture: arm64
-Depends:
- libgcc-s1:amd64 | libgcc-s1-amd64-cross,
- libstdc++6:amd64 | libstdc++6-amd64-cross,
- ${misc:Depends},
- ${shlibs:Depends},
-Conflicts:
- box64,
- box64-rpi4,
+Depends: libgcc-s1:amd64 | libgcc-s1-amd64-cross,
+         libstdc++6:amd64 | libstdc++6-amd64-cross,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Conflicts: box64, box64-rpi4
 Description: run amd64 binaries on RK3588 without emulating library calls
  Using DynaRec on arm64, box64 will dynamically recompile x64_64 code to
  aarch64 but will also translate calls to foreign library functions to
@@ -56,14 +50,11 @@
 
 Package: box64-rpi4
 Architecture: arm64
-Depends:
- libgcc-s1:amd64 | libgcc-s1-amd64-cross,
- libstdc++6:amd64 | libstdc++6-amd64-cross,
- ${misc:Depends},
- ${shlibs:Depends},
-Conflicts:
- box64,
- box64-rk3588,
+Depends: libgcc-s1:amd64 | libgcc-s1-amd64-cross,
+         libstdc++6:amd64 | libstdc++6-amd64-cross,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Conflicts: box64, box64-rk3588
 Description: run amd64 binaries on RPI4 without emulating library calls
  Using DynaRec on arm64, box64 will dynamically recompile x64_64 code to
  aarch64 but will also translate calls to foreign library functions to
