=== debian/rules ===
--- 
+++ 
@@ -35,5 +35,10 @@
 	set -exu; for p in $(PLATFORMS); do dh_auto_clean --builddirectory=build.$${p}; done
 	rm -f docs/box64.1
 
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym
+
 # https://github.com/ptitSeb/box64/issues/648
 override_dh_auto_test:
